﻿B4R=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=2.2
@EndOfDesignText@
Sub Process_Globals
	Private bc As ByteConverter
	Public Astream As AsyncStreams	
	Private server As WiFiServerSocket
	Private eeprom As EEPROM
	Private gZero As UInt = 0
	Private gInt_Zero As Int = 0
	Private const MAGIC_EEPROM As Byte = 123
	Dim macarray(6) As Byte

	Private serializator As B4RSerializator
	Private ObjectsBuffer(100) As Object
	
	'led
	Private led As Pin
'	Private Pin_ESP As D1Pins
	Private pinos As Pin
	
	Dim Timer_Led_On As Timer
	Dim Timer_Led_off As Timer
	
	Dim Timer_Sair_Programacao As Timer
	Dim Timer_Desliga_Led As Timer
	
	Dim Bt_Programar As Pin

	'Pino 12
	Private pin_12 As Pin
		
End Sub

Public Sub Start
	'Acender o led
'	led.Initialize(Pin_ESP.D0, led.MODE_OUTPUT)

	Inicia_Leds_Servidor

'	Bt_Programar.Initialize ( Pin_ESP.D1, Bt_Programar.MODE_INPUT_PULLUP) 'Using the internal pull up resistor to prevent the pin from floating.

	Timer_Desliga_Led.Initialize ( "Timer_Desliga_Led_Tick", 3000)
	Timer_Desliga_Led.Enabled = False
	
	Timer_Sair_Programacao.Initialize ( "Timer_Sair_Programacao_Tick", 10000)
	Timer_Sair_Programacao.Enabled = False


'	Log("Start Server 4: ", Main.WiFi.StartAccessPoint("SOSApp"))
'	Log("My AP ip: ", Main.WiFi.AccessPointIp)
	server.Initialize(80, "server_NewConnection")
	server.Listen

End Sub

Sub Inicia_Leds_Servidor

	pin_12.Initialize ( 12, pin_12.MODE_OUTPUT )
	pin_12.DigitalWrite ( True )

	led.Initialize(14, led.MODE_OUTPUT)
	led.DigitalWrite(True)

	Timer_Led_On.Initialize ( "timer_led_on_Tick", 3000)
	Timer_Led_On.Enabled = True

	Timer_Led_off.Initialize ( "Timer_Led_off_Tick", 200)
	Timer_Led_off.Enabled = False

End Sub

Private Sub Server_NewConnection (NewSocket As WiFiSocket)

	Astream.InitializePrefix(NewSocket.Stream, False, "astream_NewData", "astream_Error")

'	Astream.Initialize(NewSocket.Stream, "astream_NewData", "astream_Error")
'	Astream.WaitForMoreDataDelay = 100
'	Astream.MaxBufferSize = 1000
End Sub

'192.168.4.1/set/mac   - get the MAC adress
'192.168.4.1/set/redes/ssid,password   / save the ssid and password
'192.168.4.1/set/telefones/xxxxxxxxx - save the celphone number
'192.168.4.1/set/eeprom  ' read the phone number and ssid and password
Private Sub Astream_NewData (Buffer() As Byte)
	Dim  cmd ="", par1 ="", par2="", par3 = "" As String
'	Dim xResp() As Byte
	Dim xResp As String
	Dim xTele_OK, xTel_Letra As Boolean

	Dim xTel() As Byte ' = Le_Eeprom ( Main.Pos_Telefone, 20)
'	Log ( "--- buffer -------")
	Log( Buffer)
'	Log ( "--- buffer -------")

	If bc.IndexOf(Buffer, "GET") <> -1 Then
		If bc.IndexOf(Buffer, "/set") <> -1 Then
			Log ( "GET:" , Buffer )
			Log ( "*********************")
			Dim i1 As Int = 0
			Dim i2 As Int = 0
			For Each b1() As Byte In bc.Split(Buffer, " ")
				If i1 = 1 Then
					For Each b2() As Byte In bc.Split(b1, "/")
						Select i2
							Case 2
								cmd = bc.StringFromBytes(b2)
								Log ( "Comando: " , cmd )
'								Astream.Write ( "CMD: ").write( cmd ).Write(CRLF)
							Case 3
								par1 = bc.StringFromBytes(b2)
								Dim parb1 () As Byte = b2   'Telefone de quem envia
								Log ( "par1: " , par1)
'								Astream.Write ( "PAR1: ").write( par1 ).Write(CRLF)
							Case 4
								par2 = bc.StringFromBytes(b2)
								Dim parb2 () As Byte = b2
								Log ( "par2: " , par2)
'								Astream.Write ( "PAR2: ").write( par2 ).Write(CRLF)
							Case 5
								par3 = bc.StringFromBytes(b2)
								Log ( "par3: " , par3)
						End Select
						i2 = i2 + 1
					Next
				End If
				i1 = i1 + 1
			Next

			xTele_OK = True
			xTel_Letra = False
			
			If par1 = "5511998557019" Then
				xTele_OK = True
				Log ( "Tel padrão: ",  parb1 )
			Else
				If  xTel.Length >12  Then
					'Checa se número recebido comando é igual
					parb1 = bc.StringToBytes ( par1)
					Log ( "xtel: ", xTel, " - ", par1, " - ", parb2)
					For i=0 To parb1.Length-1
						If xTel(i) <> parb1(i)	Then
							If xTel_Letra  Then
								xTele_OK = True
							Else
								If ( xTel(i) > 47 )  And ( xTel(i) < 58 ) Then
									xTele_OK = False
								Else
									xTele_OK = True
									xTel_Letra = True
								End If
							
							End If
						End If
					Next
					Log ( "Tel Verificado: ", xTel, " - ", parb1 )
				End If
			End If

			Log(StackBufferUsage)
			If xTele_OK Then
				Select cmd
					Case "mac"
						Log ( "***** MAC **********")
						Log(bc.HexFromBytes(MacAddress))
						Log ( "********************")
						'Astream.Write("HTTP/1.0 200").Write(CRLF).Write(CRLF)
						Astream.Write("mac: ").Write(bc.HexFromBytes(MacAddress)).Write(CRLF)
						Astream.Write ("EOL")
					Case "rede1"  'indica as redes  par2 =string com ssid,psw;ssid,psw..... até 200 bytes
'						eeprom.WriteBytes (parb2, Main.Pos_Rede1)
'						eeprom.WriteBytes(Array As Byte(0), Main.Pos_Rede1 + par2.Length )
						Log ( "Dados Rede 1 " ,par2 )
						'Astream.Write("HTTP/1.0 200").Write(CRLF).Write(CRLF)
						Astream.Write ( "Rede_1: ").write( par2 )
						Astream.Write ("EOL")
					Case "rede2"  'indica as redes  par2 =string com ssid,psw;ssid,psw..... até 200 bytes
'						eeprom.WriteBytes (parb2, Main.Pos_Rede2)
'						eeprom.WriteBytes(Array As Byte(0), Main.Pos_Rede2 + par2.Length )
						Log ( "Dados Rede 2 " ,par2 )
						'Astream.Write("HTTP/1.0 200").Write(CRLF).Write(CRLF)
						Astream.Write ( "Rede_2: ").write( par2 )
						Astream.Write ("EOL")
					Case "rede3"  'indica as redes  par2 =string com ssid,psw;ssid,psw..... até 200 bytes
'						eeprom.WriteBytes (parb2, Main.Pos_Rede3)
'						eeprom.WriteBytes(Array As Byte(0), Main.Pos_Rede3 + par2.Length )
						Log ( "Dados Rede 3 " ,par2 )
						'Astream.Write("HTTP/1.0 200").Write(CRLF).Write(CRLF)
						Astream.Write ( "Rede_3: ").write( par2 )
						Astream.Write ("EOL")
					Case "rede4"  'indica as redes  par2 =string com ssid,psw;ssid,psw..... até 200 bytes
'						eeprom.WriteBytes (parb2, Main.Pos_Rede4)
'						eeprom.WriteBytes(Array As Byte(0), Main.Pos_Rede4 + par2.Length )
						Log ( "Dados Rede 4 " ,par2 )
						'Astream.Write("HTTP/1.0 200").Write(CRLF).Write(CRLF)
						Astream.Write ( "Rede_4: ").write( par2 )
						Astream.Write ("EOL")
					Case "rede5"  'indica as redes  par2 =string com ssid,psw;ssid,psw..... até 200 bytes
'						eeprom.WriteBytes (parb2, Main.Pos_Rede5)
'						eeprom.WriteBytes(Array As Byte(0), Main.Pos_Rede5 + par2.Length )
						Log ( "Dados Rede 5 " ,par2 )
						'Astream.Write("HTTP/1.0 200").Write(CRLF).Write(CRLF)
						Astream.Write ( "Rede_5: ").write( par2 )
						Astream.Write ("EOL")
					Case "teste"   'testar conexão rede wifi  par2=ssid e par2 psw
						xResp = Ck_Wifi ( par1, par2, True )
						'Astream.Write("HTTP/1.0 200").Write(CRLF).Write(CRLF)
						Astream.Write("IP: ").Write( xResp ).Write(CRLF)
						Astream.Write ("EOL")
						Log ( "IP: " ,xResp )
						'					Astream.Write ( bc.StringToBytes(xResp) )
					Case "telefone"  'recebe o telefone autorizado em par2
'						eeprom.WriteBytes (parb2, Main.Pos_Telefone)
'						eeprom.WriteBytes(Array As Byte(0), Main.Pos_Telefone + par2.Length )
						'Astream.Write("HTTP/1.0 200").Write(CRLF).Write(CRLF)
						Astream.Write( "Telefone; ").Write( parb2 )
						Astream.Write ("EOL")
						'					Astream.Write ( bc.StringToBytes("Telefone Salvo ")).Write ( bc.StringToBytes (par1) )
					Case "senha"  'recebe o senha autorizado em par2
						Log ( "Senha: " , parb2 )
'						eeprom.WriteBytes (parb2, Main.Pos_Senha)
'						eeprom.WriteBytes(Array As Byte(0), Main.Pos_Senha + par2.Length )
						'Astream.Write("HTTP/1.0 200").Write(CRLF).Write(CRLF)
						Astream.Write ( "Senha; ").Write ( parb2 )
						Astream.Write ("EOL")
						'					Astream.Write ( bc.StringToBytes("Telefone Salvo ")).Write ( bc.StringToBytes (par1) )
					Case "eeprom1"
						
'						Dim xTel() As Byte = Le_Eeprom ( Main.Pos_Telefone, 20)
'						Dim xTel() As Byte = Le_Eeprom ( Main.Pos_Telefone, 20)
'						Log ( "Tefefonex: ",  xTel)
'						Dim xSenha() As Byte = Le_Eeprom ( Main.Pos_Senha, 20)
'						Log ( "Senha: ",  bc.StringFromBytes (xSenha))
'						Dim xResp1() As Byte  = Le_Eeprom ( Main.Pos_Rede1, 40)
'						Log ( "Redes 1: ",  bc.StringFromBytes (xResp1 ))
'						Dim xResp2() As Byte  = Le_Eeprom ( Main.Pos_Rede2, 40)
'						Log ( "Redes 2: ",  bc.StringFromBytes (xResp2 ))
						'					Dim xResp3() As Byte  = Le_Eeprom ( Main.Pos_Rede3, 40)
						'					Log ( "Redes 3: ",  bc.StringFromBytes (xResp3 ))
						'					Dim xResp4() As Byte  = Le_Eeprom ( Main.Pos_Rede4, 40)
						'					Log ( "Redes 4: ",  bc.StringFromBytes (xResp4 ))
						'					Dim xResp5() As Byte  = Le_Eeprom ( Main.Pos_Rede5, 40)
						'					Log ( "Redes 5: ",  bc.StringFromBytes (xResp5 ))
						'Astream.Write("HTTP/1.0 200").Write(CRLF).Write(CRLF)
						
						Astream.Write( "Versao: ").Write ( "1.4" ).Write (CRLF)
						Astream.Write( "Telefone; ").Write ( xTel ).Write (CRLF)
						Astream.Write( "Senha: ").Write ( "****" ).Write (CRLF)
'						Astream.Write ("Rede 1: ").Write( xResp1).Write (CRLF)
'						Astream.Write ("Rede 2: ").Write( xResp2).Write (CRLF)
						'					Astream.Write ("Rede 3: ").Write( xResp3).Write (CRLF)
						'					Astream.Write ("Rede 4: ").Write( xResp4).Write (CRLF)
						'					Astream.Write ("Rede 5: ").Write( xResp5).Write (CRLF)
						Astream.Write ("EOL")
					Case "eeprom2"
						'					Dim xtel() As Byte = Le_Eeprom ( Main.Pos_Telefone, 20)
						'					Dim xtel() As Byte = Le_Eeprom ( Main.Pos_Telefone, 20)
						'					Log ( "Tefefonex: ",  xtel)
						'					Dim xSenha() As Byte = Le_Eeprom ( Main.Pos_Senha, 20)
						'					Log ( "Senha: ",  bc.StringFromBytes (xSenha))
						'					Dim xResp1() As Byte  = Le_Eeprom ( Main.Pos_Rede1, 40)
						'					Log ( "Redes 1: ",  bc.StringFromBytes (xResp1 ))
						'					Dim xResp2() As Byte  = Le_Eeprom ( Main.Pos_Rede2, 40)
						'					Log ( "Redes 2: ",  bc.StringFromBytes (xResp2 ))
'						Dim xResp3() As Byte  = Le_Eeprom ( Main.Pos_Rede3, 40)
'						Log ( "Redes 3: ",  bc.StringFromBytes (xResp3 ))
'						Dim xResp4() As Byte  = Le_Eeprom ( Main.Pos_Rede4, 40)
'						Log ( "Redes 4: ",  bc.StringFromBytes (xResp4 ))
'						Dim xResp5() As Byte  = Le_Eeprom ( Main.Pos_Rede5, 40)
'						Log ( "Redes 5: ",  bc.StringFromBytes (xResp5 ))
						'Astream.Write("HTTP/1.0 200").Write(CRLF).Write(CRLF)
						'					Astream.Write( "Telefone; ").Write ( xtel ).Write (CRLF)
						'					Astream.Write( "Senha: ").Write ( "****" ).Write (CRLF)
						'					Astream.Write ("Rede 1: ").Write( xResp1).Write (CRLF)
						'					Astream.Write ("Rede 2: ").Write( xResp2).Write (CRLF)
'						Astream.Write ("Rede 3: ").Write( xResp3).Write (CRLF)
'						Astream.Write ("Rede 4: ").Write( xResp4).Write (CRLF)
'						Astream.Write ("Rede 5: ").Write( xResp5).Write (CRLF)
						Astream.Write ("EOL")
					Case "clear"
						Log ( "Limpando ")
						eeprom.WriteBytes(Array As Byte(55), 0)  'indica que eeprom foi inicializada
'						eeprom.WriteBytes ( Array As Byte(0), Main.Pos_Telefone)
'						eeprom.WriteBytes ( Array As Byte(0), Main.Pos_Senha)
'						eeprom.WriteBytes ( Array As Byte(0), Main.Pos_Rede1)
'						eeprom.WriteBytes ( Array As Byte(0), Main.Pos_Rede2)
'						eeprom.WriteBytes ( Array As Byte(0), Main.Pos_Rede3)
'						eeprom.WriteBytes ( Array As Byte(0), Main.Pos_Rede4)
'						eeprom.WriteBytes ( Array As Byte(0), Main.Pos_Rede5)
						'Astream.Write("HTTP/1.0 200").Write(CRLF).Write(CRLF)
						Astream.Write( "Memória Limpa")
						Astream.Write ("EOL")
					Case "fabrica"
						eeprom.WriteBytes ( Array As Byte(0), 0)
						'Astream.Write("HTTP/1.0 200").Write(CRLF).Write(CRLF)
						Astream.Write( "Fabrica")
						Astream.Write ("EOL")
						
					Case "start"
						led.DigitalWrite(False)
						eeprom.WriteBytes(Array As Byte(MAGIC_EEPROM), 0)  'indica que eeprom foi inicializada
						'Astream.Write("HTTP/1.0 200").Write(CRLF).Write(CRLF)
						Astream.Write( "Dormindo em 1 seg")
						Astream.Write ("EOL")

						Timer_Desliga_Led.Interval = 2000
						Timer_Desliga_Led.Enabled = True
					Case Else
						'Astream.Write("HTTP/1.0 200").Write(CRLF).Write(CRLF)
						Astream.Write( "Comando Inválido")
						Astream.Write ("EOL")
				End Select
			Else
				'Astream.Write("HTTP/1.0 200").Write(CRLF).Write(CRLF)
				Astream.Write( "Er: Telefone não autorizado")
				Astream.Write ("EOL")
			End If

			'			server.Socket.Stream.Flush
			'			server.Socket.Close
			'Log ( "Flush enviado")
			'			Astream.Write("HTTP/1.1 200").Write(CRLF)
			'			Astream.Write("Content-Type: text/html").Write(CRLF).Write(CRLF)
			'			Astream.Write("<script>setTimeout(function(){location.href=""http://192.168.4.1""} , 20000);</script>")
			'			Astream.Write("WiFi set to: ").Write(ssid).Write(", password: ").Write(password).Write("<br/>Please wait...")
			'			SaveNetworkDetails(ssid, password)
			'			CallSubPlus("ConnectWifi", 500, 0)
		Else
'			Astream.Write("HTTP/1.1 404").Write(CRLF)
			Astream.Write("Er: Dados incorretos").Write(CRLF)
			Astream.Write ("EOL")
		End If
		CallSubPlus("CloseConnection", 1000, 0)
	End If
End Sub

Private Sub CloseConnection(u As Byte)
	If server.Socket.Connected Then
		server.Socket.Stream.Flush
		server.Socket.Close
		Log ( "Flush enviado")
	End If
	Log("close connection")
	server.Listen
End Sub

Private Sub AStream_Error
	Log("Disconnected")
	server.Listen
End Sub

Public Sub ReplaceString(Original() As Byte, SearchFor() As Byte, ReplaceWith() As Byte) As Byte()
	'count number of occurrences
	Dim bc2 As ByteConverter
	Dim c As Int = 0
	Dim i As Int
	If SearchFor.Length <> ReplaceWith.Length Then
		i = bc2.IndexOf(Original, SearchFor)
		Do While i > -1 
			c = c + 1
			i = bc2.IndexOf2(Original, SearchFor, i + SearchFor.Length)
		Loop
	End If
	Dim result(Original.Length + c * (ReplaceWith.Length - SearchFor.Length)) As Byte
	Dim prevIndex As Int = 0
	Dim targetIndex As Int = 0
	i = bc2.IndexOf(Original, SearchFor)
	Do While i > -1 
		bc2.ArrayCopy2(Original, prevIndex, result, targetIndex, i - prevIndex)
		targetIndex = targetIndex + i - prevIndex
		bc2.ArrayCopy2(ReplaceWith, 0, result, targetIndex, ReplaceWith.Length)
		targetIndex = targetIndex + ReplaceWith.Length
		prevIndex = i + SearchFor.Length
		i = bc2.IndexOf2(Original, SearchFor, prevIndex)
	Loop
	If prevIndex < Original.Length Then
		bc2.ArrayCopy2(Original, prevIndex, result, targetIndex, Original.Length - prevIndex)
	End If
	Return result
End Sub

'  Log(bc.HexFromBytes(MacAddress))
Sub MacAddress() As Byte()
	RunNative("getMac", Null)
	Return macarray
End Sub
#if C
  #include <ESP8266WiFi.h>
  void getMac(B4R::Object* u) {
  WiFi.macAddress((Byte*)b4r_wifiserver::_macarray->data);
  }
#end if


public Sub Ck_Wifi ( pSSId As String, pPsw As String, pDisconecta As Boolean ) As String
	Dim xIP As String
	Log("Trying to connect to: ", pSSId, " password: ", pPsw)
'	If Main.Wifi.Connect2(pSSId, pPsw) Then
'		Log("Connected successfully to: ", pSSId)
'		Log(Main.Wifi.LocalIp)
'		xIP = Main.Wifi.LocalIp
'		If pDisconecta Then Main.Wifi.Disconnect
'		Return xIP
'	Else
'		Log("Failed to connect.")
'		xIP = "Er: conexao"
''		If pDisconecta Then Main.Wifi.Disconnect
'		Return xIP
'	End If
End Sub

public  Sub Le_Eeprom ( pStart As UInt, pMax As UInt ) As Byte()
	Dim i, xCnt, ate As UInt
'	Dim xResp(100) As Byte
	i = pStart
	xCnt = 0
	ate = i + pMax
	Do While i < ate
		Dim b() As Byte = eeprom.ReadBytes(i, 1)
'		xResp (xCnt) = b(0)
'Log( b(0))
		If b(0) <> 0 Then			
			xCnt = xCnt + 1
		Else
			i = ate + 1	
		End If
		i = i + 1
	Loop
'	If xCnt = 0 Then
'		xResp(0) =  " "
'	End If
	Dim xResp() As Byte = eeprom.ReadBytes(pStart,xCnt) 
	Log ( "Bytes Lidos:" ,xCnt )
	Return xResp
End Sub


Sub Timer_Led_ON_Tick
'	Log ( "Timer OM")
	led.DigitalWrite(True)
	Timer_Led_On.Enabled = False
	Timer_Led_off.Enabled = True
End Sub

Sub timer_led_off_Tick
'	Log ( "Timer OFF")
	led.DigitalWrite(False)
	Timer_Led_On.Enabled = True
	Timer_Led_off.Enabled = False
End Sub

Sub Timer_Desliga_Led_Tick
	led.DigitalWrite(False)
	Timer_Desliga_Led.Enabled = False
'	Main.WiFi.Disconnect
	pin_12.DigitalWrite ( False )
'	ds.deepsleep(0)
	
End Sub
Sub Timer_Sair_Programacao_Tick
	Bt_Programar.AddListener("Btn_StateChanged")
	Timer_Sair_Programacao.Enabled = False
End Sub


Sub Btn_StateChanged (State As Boolean)
	If State = False Then
		Log ( "Voltando ....")
		Bt_Programar.AddListener (Null)
		pin_12.DigitalWrite ( False )
'		ds.deepsleep (0)

'		led.DigitalWrite(False)
'		Main.WiFi.Disconnect
'		Timer_Desliga_Led.Interval = 2000
'		Timer_Desliga_Led.Enabled = True
	End If
	
End Sub

